10 ' Program for folded plates using waffle slabs Version 3, Part 2
20 ' Ketchum 1990
30 ' LPRINT CHR$(27)"l"CHR$(4) ' Indent
40 DEFINT I-N: DEFDBL A-H, O-Y
50 DIM SP(8, 8),S1(6,6),F1(8),S2(8),IPC(10),IR(8)
60 '
70 ' Main program
80 CLS:PRINT:PRINT "PROGRAM FOR FOLDED PLATE - WAFFLE SLAB - ANALYSIS": PRINT
90 GOSUB 700 ' Disk input
100 '
110 ' Slab analysis
120 GOSUB 2640  ' Code numbers and equations
130 PRINT:PRINT "Assemble matrix for slab loads"
140 FOR MI=1 TO NP
150 NDC=6:IG=1
160 GOSUB 3690 '  Stiffness
170 GOSUB 1580 '  Distribution
180 NEXT MI: PRINT
190 IB=6 ' Set matrix width for slab
200 GOSUB 3940 '  Solve Matrix.
210 GOSUB 3010 ' Loads for slab analysis
220 GOSUB 4130 '  Second part of solver
230 GOSUB 3210 '  Deflections.
240 PRINT "MOMENTS IN MEMBERS and VERTICAL REACTIONS
250 P3$="MEMBER      MOM.LEFT    MOM. RIGHT   REACT.LEFT   REACT.RIGHT"
260 PRINT P3$
270 FOR MI=1 TO NP
280 GOSUB 3690 ' Stiffness matrix
290 GOSUB 3320 ' Forces
300 IF INT(MI/20)=MI/20 THEN CLS:PRINT:PRINT P3$
310 NEXT MI
320 GOSUB 3570 ' Statics Check.
330  '
340 ' Plate analysis
350 GOSUB 1000  ' Equations for code numbers for plate stresses
360 PRINT:PRINT "Assemble stress matrix"
370 NDC=8:IB=8
380 FOR M = 1 TO NP: KQ = 0' Loop for assembly
390 GOSUB 2310  ' Stiffness
400 GOSUB 1680   ' Distribution
410 NEXT M: PRINT
420 IB=8
430 GOSUB 3940 ' First part of solver
440 GOSUB 1450  ' Loads for plate analysis
450 GOSUB 3460  ' Print loads
460 GOSUB 4130  ' Second part of solver
470 GOSUB 1770  ' Deflections
480 GOSUB 1890  ' Print headings
490 FOR M = 1 TO NP  ' Loop for stresses
500 GOSUB 2310  ' Stiffness
510 GOSUB 1970  ' Forces
520 GOSUB 2040  ' Print stresses
530 NEXT M  ' End of loop for stresses
540 GOSUB 3570  ' Statics check
550 GOSUB 4460 'Prepare for next pass
660 GOTO 120 ' Next pass
670 END
680 '
690 ' Subroutine to read disk
700 PRINT : PRINT "FILES ON THIS DISK FOR DATA INPUT ": FILES: PRINT
710 INPUT "NAME OF FILE: (To change disk, insert disk and enter C) "; FILE$
720 IF FILE$ = "C" THEN 700
730 OPEN "I", 1, FILE$
740 INPUT #1, A$
750 INPUT #1, SP, E, NP, NJ,NPC
760 DIM MK(NP, 2),TH(NP),FJ(NJ,4),FEM(NP+1,2), ND(NJ, 4)
770 DIM X(NJ),Y(NJ)
780 DIM F(NJ*4),D1(NJ*4),NC(NP,8),SS(NP+1,4),SU$(NJ),TL(NJ),SI(NP)
790 FOR I = 1 TO NP: INPUT #1, MK(I, 1), MK(I, 2), TH(I),SI(I): NEXT I
800 FOR I = 1 TO NJ: INPUT #1, X(I),Y(I):NEXT I
810 FOR I=1 TO NJ:INPUT#1,SU$(I):NEXT
820 FOR I = 1 TO NJ: FOR J=1 TO 4:INPUT #1, FJ(I,J): NEXT J,I
830 FOR I = 1 TO NP: INPUT #1,TL(I):NEXT I
840 FOR I=1 TO NPC:INPUT #1,IPC(I):NEXT I
850 CLOSE
860 DIM S(NJ*4,8),FM(NJ,2),H(NP),V(NP+1),D(NP),DS(NP+1,2),FK(NJ,4)
870 DIM ICC(NP)
880 FOR I=1 TO NP:JN=MK(I,1):JF=MK(I,2)
890 H(I)=X(JF)-X(JN):V(I)=Y(JF)-Y(JN)
900 D(I)=SQR(H(I)^2+V(I)^2):NEXT
910 FOR I=1 TO  NJ:DS(I,1)=X(I):DS(I,2)=Y(I):NEXT I
920 FOR I=1 TO NJ:FOR J=1 TO 4:FK(I,J)=FJ(I,J):NEXT J,I
930 FOR I=1 TO N1:F(I)=0:D1(I)=0:NEXT I
940 CLS:PRINT:PRINT "PART 2 - TAPERED FOLDED PLATE ANALYSIS"
950 PRINT:PRINT "JOB IDENTIFICATION ";A$
960 RETURN
970  '
980  '
990 '  Supports and releases for plate analysis
1000 FOR I=1 TO N1:F(I)=0:D1(I)=0:FOR J=1 TO 8:S(I,J)=0:NEXT J,I
1010 FOR I=1 TO NJ:FOR J=1 TO 4:ND(I,J)=1:NEXT J,I
1020 FOR I=1 TO NJ
1030 IF SU$(I)="SY" THEN ND(I,1)=0:ND(I,4)=0
1040 IF SU$(I)="VS" THEN ND(I,2)=0
1050 IF SU$(I)="FX" THEN ND(I,1)=0:ND(I,2)=0:ND(I,3)=0:ND(I,4)=0
1060 IF SU$(I)="HS" THEN ND(I,1)=0
1070 NEXT I
1080 ' ICC( ) set to 0 for flag
1090 FOR I=1 TO  NP:ICC(0)=0:FOR J=1 TO NPC
1100 IF IPC(J)=I THEN 1110 ELSE 1120
1110 ICC(I)=1
1120 NEXT J
1130 NEXT I
1140 FOR I=1 TO NP
1150 IF ICC(I)=0 THEN 1170
1160 IF ICC(I)+ICC(I+1)=2 THEN ND(I+1,3)=0
1170 NEXT I
1180 '
1190 NQ = 0
1200 FOR I = 1 TO NJ: FOR J = 1 TO 4
1210 IF ND(I, J) = O THEN 1230
1220 NQ = NQ + 1: ND(I, J) = NQ
1230 NEXT J, I
1240 N1=NQ
1250 IB=8
1260 '
1270 FOR I = 1 TO NP: JN = MK(I, 1): JM = MK(I, 2)
1280 FOR J = 1 TO 4: NC(I, J) = ND(JN, J): NC(I, J + 4) = ND(JM, J)
1290 NEXT J, I
1300 '
1310 ' Assign code numbers
1320 FOR I=1 TO NJ:FOR J=1 TO 4:F(ND(I,J))=FJ(I,J):NEXT J,I
1330 FOR I=1 TO N1:D1(I)=F(I):NEXT
1340 PRINT:PRINT "CODE NUMBERS FOR PLATE ANALYSIS"
1350 P11$= "JOINT  X    Y    Z   PHI":PRINT P11$
1360 FOR I=1 TO NJ
1370 PRINT USING "###  ";I;ND(I,1);ND(I,2);ND(I,3),ND(I,4)
1380 IF INT(I/20)=I/20 THEN PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT P11$
1390 NEXT I
1400 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
1410 RETURN
1420 '
1430 '
1440 ' Loads for plate analysis
1450 FOR I=1 TO NJ
1460 FJ(I,2)=FJ(I,2)+SS(I-1,2)+SS(I,1)
1470 NEXT I
1480 FOR I=1 TO NJ
1490 F(ND(I,1))=FJ(I,1):F(ND(I,2))=FJ(I,2)
1500 IF SU$(I)="NF" OR SU$(I)="E" THEN F(ND(I,2))=0
1510 NEXT I
1520 FOR I=1 TO N1:D1(I)=F(I):NEXT
1530 PRINT : INPUT "<ENTER> TO CONTINUE "; ZZ: CLS : PRINT
1540 RETURN
1550 '
1560 '
1570  ' Assembly of slab matrix
1580 FOR I = 1 TO NDC: IF NC(MI, I) = 0 THEN 1630
1590 K = NC(MI, I): FOR J = 1 TO NDC: IF NC(MI, J) = 0 THEN 1620
1600 L = NC(MI, J): IF (K - L) > 0 THEN 1620
1610 L1 = L - K + 1: S(K, L1) = S(K, L1) + S1(I, J)
1620 NEXT J
1630 NEXT I
1640 RETURN
1650 '
1660 '
1670  ' Assembly of plate matrix
1680 FOR I = 1 TO NDC: IF NC(M, I) = 0 THEN 1730
1690 K = NC(M, I): FOR J = 1 TO NDC: IF NC(M, J) = 0 THEN 1720
1700 L = NC(M, J): IF (K - L) > 0 THEN 1720
1710 L1 = L - K + 1: S(K, L1) = S(K, L1) + SP(I, J)
1720 NEXT J
1730 NEXT I
1740 RETURN
1750 '
1760 '
1770 PRINT : CFD = 1.2481
1780 CLS : PRINT "DEFLECTIONS, INCHES"
1790 PD$ = "JOINT     X          Y          Z       ROTATION": PRINT PD$
1800 FOR I = 1 TO NJ: PRINT USING "#### "; I;
1810 PRINT USING " ###.##### ";D1(ND(I, 1))*CFD*12/E,D1(ND(I,2))*CFD*12/E;
1820 PRINT USING " ###.##### ";D1(ND(I, 3))*CFD*12/E,D1(ND(I, 4))*CFD/E
1830 IF INT(I / 20) = I / 20 AND NJ <> 20 THEN INPUT "<ENTER> TO CONTINUE "; ZZ: CLS : PRINT : PRINT PD$
1840 NEXT I
1850 PRINT : INPUT "<ENTER> TO CONTINUE "; ZZ: CLS : PRINT
1860 RETURN
1870 '
1880  '
1890 KQ = 1
1900 PRINT : PRINT "STRESSES IN PLATES "
1910 P4$= "  PLATE        SHEAR       STRESS       MOMENT       THRUST     S.SHEAR"
1920 P5$= "                psi          psi        pounds        pounds    pounds"
1930 PRINT P4$:PRINT P5$
1940 RETURN
1950 '
1960 '  Subroutine for forces
1970 FOR I = 1 TO 8: IR(I) = NC(M, I): NEXT I
1980 FOR I = 1 TO 8: F1(I) = D1(IR(I)): NEXT I
1990 FOR I = 1 TO 8: S2(I) = 0: FOR J = 1 TO 8
2000 S2(I) = S2(I) + SP(I, J) * F1(J): NEXT J: NEXT I
2010 FEM(M, 1) = S2(4) - FEM(M, 1): FEM(M, 2) = S2(8) - FEM(M, 2)
2020 RETURN
2030  '
2040 PRINT USING "### NEAR "; M;
2050 J1 = NC(M, 3): J2 = NC(M, 7)
2060 CFS = 1.57035:CFM = 1.2732: CFF = 3.8046
2070  ' Stress
2080 SA = D1(J1) * CFF / SP: SB = -D1(J2) * CFF / SP
2090  ' Shear
2100 SC = S2(3) * CFS / TH(M): SD = S2(7) * CFS / TH(M)
2110  ' Thrust
2120 SE = (S2(1) * H(M) + S2(2) * V(M))/ D(M)
2130 SF = (S2(5) * H(M) + S2(6) * V(M))/ D(M)
2140  ' Moment
2150 SML = S2(4) * CFM + FEM(M, 1): SMR = S2(8) * CFM + FEM(M, 2)
2160 ' Slab shear
2170 SQI = 144
2180 SSN=-(SML+SMR)/D(M)+TL(M)*H(M)/D(M)/2
2190 SSF=-(SML+SMR)/D(M)-TL(M)*H(M)/D(M)/2
2200 PRINT USING " ####,###.#  "; -SC / SQI, SA / SQI,SML;
2210 PRINT USING " ####,###.#  "; SE / SQI,SSN
2220 PRINT USING "### FAR  "; M;
2230 PRINT USING " ####,###.#  "; SD / SQI, -SB / SQI,-SMR;
2240 PRINT USING " ####,###.#  "; -SF / SQI,SSF
2250 IF INT(M/10)=M/10 THEN PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT:PRINT P4$:PRINT P5$
2260 FOR I = 1 TO 8: F(NC(M, I)) = F(NC(M, I)) - S2(I): NEXT I
2270 VN = RM
2280 RETURN
2290 '
2300 ' Subroutine for plate stiffness.
2310 N=1
2320 D=D(M):PI=3.141593:SI=TH(M)^3/12:R=SI/D
2330 A11=4*SI/D:B=2*R:CS=6*R/D:DS=12*R/(D*D):C1=TH(M)*D*N*N*PI*PI/(4*SP*SP)
2340 C2=C1/3+TH(M)/(2*D):C3=TH(M)/D:C4=-TH(M)*N*PI/(4*SP):C5=C1/2
2350 EP=C1+C2:FP=C1-C2:GP=EP:HP=C4:TI=C3+C5:TJ=C3-C5:TL=V(M)/D
2360 TM=H(M)/D
2370 SP(1,1)=DS*TL*TL+TI*TM*TM:SP(1,2)=DS*TM*TL-TI*TM*TL
2380 SP(1,3)=-HP*TM:SP(1,4)=-CS*TL:SP(1,5)=-DS*TL*TL-TJ*TM*TM
2390 SP(1,6)=-DS*TL*TM+TJ*TL*TM:SP(1,7)=HP*TM:SP(1,8)=-CS*TL
2400 SP(2,2)=DS*TM*TM+TI*TL*TL:SP(2,3)= HP*TL:SP(2,4)=-CS*TM
2410 SP(2,5)=-DS*TM*TL+TJ*TM*TL:SP(2,6)=-DS*TM*TM-TJ*TL*TL
2420 SP(2,7)=-HP*TL:SP(2,8)=-CS*TM
2430 SP(3,3)=EP:SP(3,4)=0:SP(3,5)=SP(1,3):SP(3,6)=SP(2,3)
2440 SP(3,7)=FP:SP(3,8)=0
2450 SP(4,4)=A11:SP(4,5)=CS*TL:SP(4,6)=CS*TM:SP(4,7)=0:SP(4,8)=B
2460 SP(5,5)=SP(1,1):SP(5,6)=SP(1,2):SP(5,7)=SP(1,7)
2470 SP(5,8)=-SP(1,8):SP(6,6)=SP(2,2)
2480 SP(6,7)=SP(2,7):SP(6,8)=-SP(2,8):SP(7,7)=GP:SP(7,8)=0:SP(8,8)=A11
2490 ' FOR I=1 TO 8:PRINT:FOR J=1 TO 8:PRINT USING "##.#### ";SP(I,J);:NEXT J,I:STOP
2500 IF KQ=0 THEN 2540
2510 K=1:FOR I=2 TO 8:FOR J=1 TO K:SP(I,J)=SP(J,I)
2520 NEXT J:K=K+1:NEXT I
2530 ' Modify plate stiffness
2540 IF NPC=0 THEN 2610
2550 FOR I=1 TO 8
2560 FOR J=1 TO NPC
2570 IF M=IPC(J) THEN 2580 ELSE 2590
2580 SP(3,I)=0:SP(7,I)=0:SP(I,3)=0:SP(I,7)=0
2590 NEXT J
2600 NEXT I
2610 RETURN
2620 '
2630 ' Supports and releases for slab analysis
2640 FOR I=1 TO NJ:FOR J=1 TO 3:ND(I,J)=1:NEXT J,I
2650 FOR I=1 TO NJ
2660 IF SU$(I)="SY" THEN ND(I,1)=0:ND(I,2)=0:ND(I,3)=0
2670 IF SU$(I)="F" THEN ND(I,2)=0
2680 IF SU$(I)="VS" THEN ND(I,2)=0
2690 IF SU$(I)="FX" THEN ND(I,1)=0:ND(I,2)=0:ND(I,3)=0
2700 IF SU$(I)="HS" THEN ND(I,1)=0
2710 NEXT I
2720 '
2730 N1=0
2740 FOR I=1 TO NJ
2750 N1=N1+1
2760 FOR J=1 TO 3
2770 IF ND(I,J)=0 THEN 2800  
2780 ND(I,J)=N1
2790 N1=N1+1
2800 NEXT J
2810 N1=N1-1:NEXT I
2820 '
2830 PRINT:PRINT "SECTION A - JOINT LOADS ON FOLDED PLATE"
2840 PRINT:PRINT "THERE ARE ";N1;" EQUATIONS":PRINT
2850 '
2860 PRINT "CODE NUMBERS FOR SLAB ANALYSIS"
2870 P1$="JOINT   X      Y     PHI":PRINT P1$
2880 '
2890 FOR I = 1 TO NP: JN = MK(I, 1): JM = MK(I, 2)
2900 FOR J = 1 TO 3: NC(I, J) = ND(JN, J): NC(I, J + 3) = ND(JM, J)
2910 NEXT J,I
2920 FOR I=1 TO NJ:PRINT USING "### ";I;:FOR J=1 TO 3:PRINT USING "  ###  ";ND(I,J);
2930 NEXT J
2940 IF INT(I/20)=I/20 THEN PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT P1$
2950 PRINT:NEXT I
2960 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
2970 RETURN
2980 '
2990 '
3000 ' Loads for slab analysis
3010 FOR I=1 TO NP:FEM(I,1)=TL(I)*H(I)/12:FEM(I,2)=-FEM(I,1):NEXT I
3020 FOR I=1 TO NP:F(NC(I,3))=FEM(I-1,2)+FEM(I,1):NEXT I
3030 FOR I=1 TO NJ
3040 IF SU$(I)="NF" OR SU$(I)= "E" THEN FJ(I,2)=FJ(I,2)+TL(I-1)/2+TL(I)/2
3050 NEXT I
3060 FOR I=1 TO NJ:F(ND(I,1))=FJ(I,1):F(ND(I,2))=FJ(I,2):NEXT I
3070 PRINT "SLAB JOINT FORCES "
3080 P2$="JOINT          X            Y          MOMENT":PRINT P2$
3090 FOR I=1 TO NJ:
3100 PRINT USING "###    ";I;
3110 FOR J=1 TO 3
3120 PRINT USING "###,###.###  ";F(ND(I,J));
3130 NEXT J
3140 IF INT(I/20)=I/20 THEN PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT:PRINT P2$
3150 PRINT:NEXT I
3160 FOR I=1 TO N1:D1(I)=F(I):NEXT I
3170 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
3180 RETURN
3190 '
3200 '
3210 PRINT:PRINT "DEFLECTIONS OF SLAB, INCHES"
3220 P9$="JOINT   X       Y      PHI":PRINT P9$
3230 D1(0)=0:FOR I=1 TO NJ:PRINT I;:FOR J=1 TO 3
3240 PRINT USING "###.#### ";D1(ND(I,J))*12/E;
3250 NEXT J
3260 PRINT:IF INT(I/20)=I/20 THEN INPUT "<ENTER> TO CONTINUE ";ZZ:PRINT:PRINT P9$
3270 NEXT I
3280 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
3290 RETURN
3300 '
3310 '  Member forces
3320 FOR I=1 TO 6:F1(I)=D1(NC(MI,I)):NEXT
3330 FOR I=1 TO 6:S2(I)=0:FOR J=1 TO 6
3340 S2(I)=S2(I)+S1(I,J)*F1(J):NEXT J,I
3350 SS(MI,1)=S2(5)+TL(MI)/2:SS(MI,2)=S2(2)+TL(MI)/2
3360 FOR I=1 TO 6:F(NC(MI,I))=F(NC(MI,I))-S2(I):NEXT I
3370 FEM(MI,1)=FEM(MI,1)-S2(3):FEM(MI,2)=FEM(MI,2)-S2(6)
3380 '
3390 PRINT USING "  ###   ";MI;
3400 PRINT USING "####,###.##  ";FEM(MI,1),FEM(MI,2),SS(MI,1),SS(MI,2)
3410 IF INT(MI/20)=MI/20 THEN INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT:PRINT P3$
3420 RETURN
3430 '
3440 '
3450 ' Print joint loads
3460 PRINT:PRINT "JOINT FORCES INCLUDING ADDITIONAL FORCES"
3470 P10$= "JOINT        X          Y          PRESTRESS    MOMENT":PRINT P10$
3480 FOR I=1 TO NJ
3490 PRINT USING "###  ";I;
3500 PRINT USING "###,###.###  ";F(ND(I,1)),F(ND(I,2)),F(ND(I,3)),F(ND(I,4))
3510 IF INT(I/20)=I/20 THEN INPUT "<ENTER> TO CONTINUE ";ZZ:PRINT:CLS:PRINT P10$
3520 NEXT I
3530 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
3540 RETURN
3550 '
3560 '
3570 PRINT : INPUT "<ENTER> TO CONTINUE "; Z: CLS
3580 PRINT:PRINT "STATICS CHECK FOR RESIDUALS MORE THAN 0.001":PRINT
3590 FOR I=1 TO N1:IF F(I)<.001 THEN 3620
3600 PRINT USING "RESIDUAL AT CODE NO. ### IS ###.### ";I,F(I)
3610 K=1
3620 NEXT I:IF K=1 THEN 3640
3630 PRINT "** ALL RESIDUALS ARE LESS THAN 0.001 **"
3640 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
3650 RETURN
3660 '
3670  '
3680 ' Stiffness Subroutine for frame analysis
3690 X=H(MI):Y=V(MI)
3700 AL=D(MI):A=TH(MI):XI=SI(MI):AV=0
3710 DM=X/AL:DN=Y/AL
3720 AK=XI/AL:AA=4*AK:S=A/AL:B=2*AK:C=6*AK/AL
3730 D=12*AK/AL/AL
3740 F=S*DM*DM+D*DN*DN
3750 G=S*DM*DN-D*DM*DN
3760 P=S*DN*DN+D*DM*DM
3770 H=C*DN:Q=C*DM
3780 S1(1,1)=F :S1(1,2)=G :S1(1,3)= H
3790 S1(1,4)=-F:S1(1,5)=-G:S1(1,6)= H
3800 S1(2,1)=G :S1(2,2)=P :S1(2,3)= Q
3810 S1(2,4)=-G:S1(2,5)=-P:S1(2,6)= Q
3820 S1(3,1)=H :S1(3,2)=Q :S1(3,3)= AA
3830 S1(3,4)=-H:S1(3,5)=-Q:S1(3,6)= B
3840 S1(4,1)=-F:S1(4,2)=-G:S1(4,3)=-H
3850 S1(4,4)=F :S1(4,5)=G :S1(4,6)=-H
3860 S1(5,1)=-G:S1(5,2)=-P:S1(5,3)=-Q
3870 S1(5,4)=G :S1(5,5)=P :S1(5,6)=-Q
3880 S1(6,1)=H :S1(6,2)=Q :S1(6,3)= B
3890 S1(6,4)=-H:S1(6,5)=-Q:S1(6,6)= AA
3900 RETURN
3910 '
3920 '
3930 ' First part of solver
3940 PRINT "Solving equations  "
3950 FOR N=1 TO N1
3960 FOR LL=2 TO IB
3970 C=S(N,LL)/S(N,1)
3980 I=N+LL-1
3990 IF (N1-I)<0 THEN 4070 
4000 J=0
4010 FOR K=LL TO IB
4020 J=J+1
4030 S(I,J)=S(I,J)-C*S(N,K)
4040 NEXT K
4050 S(N,LL)=C
4060 NEXT LL
4070 NEXT N
4080 PRINT
4090 RETURN
4100 '
4110  '
4120  ' Second part of solver.
4130 PRINT:PRINT "Second part of solver"
4140 FOR N=1 TO N1
4150 FOR LL=2 TO IB
4160 I=N+LL-1
4170 IF (N1-I)<0 THEN 4200 
4180 D1(I)=D1(I)-S(N,LL)*D1(N)
4190 NEXT LL
4200 D1(N)=D1(N)/S(N,1)
4210 NEXT N
4220 N=N1
4230 N=N-1
4240 IF (N)=0 THEN 4310 
4250 FOR K=2 TO IB
4260 LL=N+K-1
4270 IF(N1-LL)<0 THEN 4290
4280 D1(N)=D1(N)-S(N,K)*D1(LL)
4290 NEXT K
4300 GOTO 4230 
4310 RETURN
4320 ' Revised coordinates
4330 FOR I=1 TO NJ:KX=ND(I,1):KY=ND(I,2)
4340 X(I)=DS(I,1)-D1(KX)/E:Y(I)=DS(I,2)-D1(KY)/E
4350 NEXT
4360 PRINT "REVISED COORDINATES"
4370 PRINT "JOINT       X          Y"
4380 FOR I=1 TO NJ:PRINT USING "###  ";I;
4390 PRINT USING "#,###.###  ";X(I),Y(I)
4400  IF I=20 THEN INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
4410 NEXT
4420 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
4430 RETURN
4440 '
4450 ' Prepare for next pass
4460 PRINT:INPUT "<ENTER> FOR NEXT PASS OF <R> FOR NEW DATA "; Q$
4470 IF Q$ = "R" THEN CLEAR : GOTO 10
4480 GOSUB 4330 ' Revised  Coordinates
4490 XX=1:FOR I=1 TO NJ*4:F(I)=0:D1(I)=0:NEXT
4500 FOR I=1 TO NJ*4:FOR J=1 TO 8:S(I,J)=0:NEXT J,I
4510 IG=IG+1
4520 PRINT "PASS NO. ";IG
4530 FOR I=1 TO NP:JN=MK(I,1):JF=MK(I,2)
4540 H(I)=X(JF)-X(JN):V(I)=Y(JF)-Y(JN)
4550 D(I)=SQR(H(I)^2+V(I)^2):NEXT
4560 RETURN
