20 ' Program for folded plates using waffle slabs Ketchum 1991, Version 3
30 ' Part 1 of set: Preparation for disk input.
40 DEFDBL A-H,O-Y: DEFINT I-N:CLEAR 80
45 RESTORE 3000
50 ' Main program
60 GOSUB 180 ' Parameters
70 GOSUB 330  ' Incidences, thicknesses
80 GOSUB 490  ' Support conditions, coordinates
90 GOSUB 800  ' Joint loads
100 GOSUB 1170  ' Uniform loads
110 GOSUB 950  ' Disk output
120 PRINT:INPUT "DO YOU WISH TO SAVE THIS PROGRAM ? (Y/N) ";ZZZ$
130 IF ZZZ$="Y" THEN 140 ELSE 160
140 PRINT:PRINT "FILES ON THIS DISK ":PRINT:FILES
150 PRINT:PRINT "PRESS F4"
160 END
170 '
180 CLS:PRINT "FOLDED PLATE ANALYSIS "
190 READ A$
200 PRINT:PRINT "JOB IDENTIFICATION: ";A$:PRINT
210 PRINT "For this version dimensions are in feet, loads are in pounds,"
220 PRINT "and stresses are in psi or pounds as noted."
230 READ SP,E,NP,DN:NJ=NP+1
240 DIM MK(NP,2),X(NJ),Y(NJ),TH(NP),SL(NP),RL(NP),TL(NP)
250 DIM II(NJ),FY(4),FJ(NJ,4),FEM(NJ,2),DJ(NJ,2),BK(NP+2,2),ND(NJ*4,4),SU$(NJ)
260 DIM SI(NP),H(NP),V(NP),D(NP)
270 PRINT: PRINT "SPAN = ";SP;"  MOD.ELAS. = ";E;
280 PRINT "  NO. PLATES = ";NP;"  NO. OF JOINTS = ";NJ
290 PRINT "DENSITY OF CONCRETE  ";DN
300 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
310 RETURN
320 '
330 FOR I=1 TO NP:MK(I,1)=I:MK(I,2)=I+1
340 NEXT
350 PRINT "MEMBER THICKNESSES"
360 PRINT "MEMBER    THICKNESS REV.M OF I   SNOW LOAD   ROOF LOAD"
370 FOR I=1 TO NP
380 READ ID,TH(I),SI(I),SL(I),RL(I)
390 PRINT USING "###     ";I;
400 PRINT USING " #,###.### ";TH(I),SI(I),SL(I),RL(I)
410 IF INT(I/20)=I/20 THEN PRINT:INPUT "<ENTER>TO CONTINUE> ";ZZ:CLS:PRINT
420 IF SI(I)=0 THEN SI(I)=TH(I)^3/12
430 NEXT
440 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
450 FOR I=1 TO NJ:FOR J=1 TO 4:ND(I,J)=1:NEXT J,I
460 RETURN
470 '
480 PRINT
490 PRINT:PRINT "LIST OF SUPPORT CONDITIONS":PRINT
500 PRINT "INTERIOR FOLD                  F"
510 PRINT "END                            E"
520 PRINT "SYMMETRY                      SY"
530 PRINT "NO FOLD                       NF"
540 PRINT "VERTICAL SUPPORT              VS"
550 PRINT "FIX (BASE ONLY)               FX"
560 PRINT "HORIZONTAL SUPPORT ONLY       HS"
570 '
580 READ NPC
590 PRINT:PRINT "NO. OF MEMBERS WITH NO PLATE ACTION ";NPC
600 IF NPC=0 THEN 630
610 PRINT "MEMBERS WITH NO PLATE ACTION: ";
620 FOR I=1 TO NPC:READ IPC(I):PRINT IPC(I);:NEXT:PRINT
630 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
640 PRINT:PRINT "COORDINATES AND SUPPORT CONDITIONS":PRINT
650 P$="JOINT      X         Y      SUPPORT COND.":PRINT P$
660 '
670 FOR I=1 TO NJ
680 READ ID,X(I),Y(I),SU$(I)
690 PRINT USING "## ";I;
700 PRINT USING "##,###.### ##,###.###        \      \";X(I),Y(I),SU$(I)
710 IF INT(I/20)=I/20 THEN PRINT:INPUT "<ENTER>TO CONTINUE> ";ZZ:CLS:PRINT
720 NEXT I
730 FOR I=1 TO NP:JN=MK(I,1):JF=MK(I,2)
740 H(I)=X(JF)-X(JN):V(I)=Y(JF)-Y(JN)
750 D(I)=SQR(H(I)^2+V(I)^2):NEXT I
760 INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
770 RETURN
780 '
790 '
800 READ NJL
810 PRINT:PRINT "NUMBER OF ADDITIONAL JOINT LOADS = ";NJL
820 IF NJL=0 THEN 910
830 PRINT "JOINT LOADS":PRINT "Positive directions are to the left and down."
840 PRINT "JOINT      X          Y       P.STRESS    MOMENT"
850 FOR I=1 TO NJL:READ II(I)
860 PRINT USING "### ";II(I);
870 FOR J=1 TO 4:READ FX(J)
880 FJ(II(I),J)=FX(J)
890 PRINT USING "##,###.####";FX(J);
900 NEXT J:PRINT:NEXT I
910 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS:PRINT
920 RETURN
930 '
940 ' Subroutine to save to disk
950 PRINT:INPUT "DO YOU WISH TO SAVE THIS DATA TO DISK ? (Y/N) ";ZZ$
960 IF ZZ$= "N" THEN RETURN
970 PRINT:PRINT "FILES ON THIS DISK":FILES:PRINT
980 PRINT:PRINT "NOTE: To  change disks, insert disk and enter C, to exit enter N"
990 INPUT "NAME OF FILE:  ";FILE$
1000 IF FILE$="C" THEN 970
1010 IF FILE$="N" THEN END
1020 OPEN "O",1,FILE$
1030 PRINT#1,A$
1040 PRINT#1,SP,E,NP,NJ,NPC
1050 FOR I=1 TO NP:PRINT#1,MK(I,1),MK(I,2),TH(I),SI(I):NEXT I
1060 FOR I=1 TO NJ:PRINT#1,X(I),Y(I):NEXT I
1070 FOR I=1 TO NJ:PRINT#1,SU$(I):NEXT
1080 FOR I=1 TO NJ:FOR J=1 TO 4:PRINT#1,FJ(I,J):NEXT J,I
1090 FOR I=1 TO NP:PRINT#1,TL(I):NEXT I
1100 FOR I=1 TO NPC:PRINT#1,IPC(I):NEXT I
1110 CLOSE
1120 PRINT:INPUT "TO SAVE TO ANOTHER DISK, CHANGE DISKS AND ENTER Y/N ";ZZ$
1130 IF ZZ$="Y" THEN 970 ELSE RETURN
1140 RETURN
1150 '
1160 ' Slab loads and moments
1170 FOR I=1 TO NP
1180 TL(I)=SL(I)*H(I)+RL(I)*D(I)+DN*TH(I)*D(I)
1190 NEXT
1200 RETURN
1210 '
2000 '  Project description
2010 DATA WAFFLE - DESIGN NO. 3 - FULL ULTIMATE LOADS
2020 '  Span, E, No. of members
2030 DATA 300,2.69E+8,11,210
2040 '  Member and thickness, roof load, snow load
2050 DATA 1,.5,.2,0,0, 2,.99,.391,0,0, 3,.99,.391,0,0, 4,.99,.391,0,0, 5,2.04,0,65,0
2060 DATA 6,2.04,0,65,0,  7,.99,.299,65,0, 8,.99,.299,65,0, 9,2.04,0,65,0
2070 DATA 10,2.04,0,65,0, 11,.99,.299,65,0
2080 ' Members with no plate action
2090 DATA 4,1,2,3,4
2100 '  Coordinates: joint, X, Y, end condition, (Run program to see symbols)
2110 DATA 1,0,-10,FX, 2,0,0,HS, 3,0,6.66,NF, 4,0,13.33,NF, 5,0,20,NF
2120 DATA 6,0,25,F, 7,10,29.17,NF, 8,30,37.5,NF, 9,50,45.83,NF, 10,60,50,F
2130 DATA 11,70,50,NF, 12,95,50,SY
2140 '  No. additional concentrated loads, Joint, X, Y, Prestress, Moment
2150 DATA 0
2160 ' End of data input.
2170 '
3000 '  Project description
3010 DATA TEST 4 ELEMENT PLATE
3020 '  Span, E, No. of members
3030 DATA 40,4.28E+8,6,150
3040 '  Member and thickness, roof load, snow load
3050 DATA 1,.667,0,0,20, 2,.333,0,0,20, 3,.333,0,0,20, 4,.333,0,0,20, 5,.333,0,0,20, 6,.667,0,0,20
3060 ' Members with no plate action
3070 DATA 0
3080 '  Coordinates: joint, X, Y, end condition, (Run program to see symbols)
3090 DATA 1,0,0,SY, 2,2.5,1.5,NF, 3,5,3,F, 4,10,4,F, 5,15,3,F, 6,17.5,1.5,NF, 7,20,0,SY
3100 '  No. additional concentrated loads, Joint, X, Y, Prestress, Moment
3110 DATA 0
